#include "Token.h"
#include <sstream>

Token::Token(TokenType tt, int line) : type(tt), line(line)
{
}

Token::~Token()
{
}

TokenType Token::getType() const
{
    return type;
}

int Token::getLine() const
{
    return line;
}

const void* Token::getData() const
{
    return nullptr;
}

string Token::getDataString() const
{
    return "";
}

string Token::toString() const
{
    stringstream ss;
    ss << '(';
    ss << line;
    ss << ", ";
    ss << TokenTypeUtils::getEnumName(type);
    if(getData() != nullptr)
    {
        ss << ", ";
        ss << getDataString();
    }
    ss << ')';
    return ss.str();
}
